require_relative "environment"

require "pretzel/core"
require "pretzel/orm"
Database = Pretzel::ORM::Database.sqlite("scrap.db")

require "pretzel/ext/templating"
require "pretzel/ext/accounts" 

Database.alter_table :pretzel_users do
  add_column :role, :string
end

class CustomUser < Pretzel::Accounts::User
  set_dataset :pretzel_users
  exposes :name, :password, :role
end

user = CustomUser.create(
  :name => "Richard",
  :password => "something",
  :role => "Admin"
)

class Application < Pretzel::Core
  extends Pretzel::Extension::Templating
  extends Pretzel::Accounts
end

Application.get "/login" do
  if user.authenticate? "something"
    login user
  end
end

Application.error 401 do
  render :auth_error
end


Application.get "/" do
  requires_authentication
  render :index, {
    "something" => "Test!",
    "current_user" => CustomUser.find(:id => session[:user])
  }
end

Rack::Handler::Thin.run Application.new